#include <windows.h>
#include <stdio.h>

#define BUFFER_SIZE 1024

typedef struct {
  char type;  // 'B','D','O'
  short no;
} item_t;
struct _step;
typedef struct _step {
  int no;
  item_t *srcitem;
  int dstcount;
  item_t *dstitem;
  struct _step *next;
} step_t;
typedef struct {
  int dropcount;
  item_t *dropitem;
} drop_t;
struct _section;
typedef struct _section {
  char *name;
  step_t *step;
  drop_t *drop;
  struct _section *next;
} section_t;

#define isnumber(c)	((c)>='0'&&(c)<='9')

typedef void WINAPI (*funcGetInfo_t)(char *WorkPath,char *FuncName,char *ShowName,char *AuthorName,char *Version,char *Start,WORD Size);
typedef void WINAPI (*funcDownload_t)(char *WorkPath,char *tempFileName,char *FindStr);

//svV[Wî܂܂OKj
char PLUGIN_FuncName[] = "funcDownload";
char PLUGIN_FuncName_base[] = "funcDownloadDummy";

//\
char PLUGIN_ShowName[1024];
char PLUGIN_ShowName_base[] = "ړ for plugin";
char PLUGIN_ShowName_base_error[] = "ړ for plugin(%s)";
char PLUGIN_ShowName_search[] = "ړ for %s";

//Җ
char PLUGIN_AuthorName[] = "Weyk";

//o[W
char PLUGIN_Version[] = "0.0.2";

//{Ǘs
/*0Fs
  1FN̂
  2FNEs
  3FISBNP̌
  4FISBN擾 */
char PLUGIN_Start[] = "3";
char PLUGIN_Start_base[] = "0";

//{̃o[W
char PLUGIN_Required[] = "0.0.1";

//ݒt@CBPluginFolder̉ɂ͂B
char szIniFileName[]="WeykExchange.ini";
//̃t@CBȊÕt@ĈƂ͂Ȃ񂩎g͂B
char szOriginalFileName[]="WeykExchange.dll";
//ꎞt@C쐬pPrefixBR܂ŁB
char szPrefix[]="wyk";
//PluginƘAgƂ̃t@C̃TtBbNXB
char szSufix[]="_exchange.dll";

HMODULE hPlugin=NULL;
HMODULE hMain=NULL;
HINSTANCE hInstance=NULL;
char szPlugin[1024];
char szMainFileName[MAX_PATH+1];
char szBaseFolder[MAX_PATH+1];
char szPluginFolder[MAX_PATH+1];
char szMyFileName[MAX_PATH+1];
section_t *pSectionTop=NULL;

//FILE *dfp=NULL;

int freeIniFile(section_t *pSectionTop);
void freeIniSection(section_t *pSection);

int Item2Index(char type,int no) {
  int iBaseNum=19;
  int iDetailsNum=14;
  int iOtherNum=13;
  int iRtn;

  if (type=='B') {
    if (no<1||no>iBaseNum) {
      iRtn=0;
    } else {
      iRtn=no;
    }
  } else
  if (type=='D') {
    if (no<1||no>iDetailsNum) {
      iRtn=0;
    } else {
      iRtn=no+iBaseNum+1;
      if (no>6) {
        iRtn+=2;
      }
      if (no>8) {
        iRtn+=2;
      }
      if (no>9) {
        iRtn+=2;
      }
    }
  } else
  if (type=='O') {
    if (no<1||no>iOtherNum) {
      iRtn=0;
    } else {
      iRtn=no+iBaseNum+1+iDetailsNum+2*3+1;
      if (no>3) {
        iRtn+=2;
      }
      if (no>5) {
        iRtn+=2;
      }
      if (no>6) {
        iRtn+=2;
      }
      if (no>7) {
        iRtn+=2;
      }
      if (no>8) {
        iRtn+=2;
      }
      if (no>9) {
        iRtn+=2;
      }
      if (no>10) {
        iRtn+=2;
      }
    }
  } else {
    iRtn=0;
  }
  return iRtn;
}

BOOL isDateItem(char type,int no) {
  BOOL bRtn=FALSE;

  if (type=='B') {
    // tڂ͖
  } else
  if (type=='D') {
    if (no==6||no==8||no==9) {
      bRtn=TRUE;
    }
  } else
  if (type=='O') {
    if (no==3||no==5||no==6||no==7||no==8||no==9||no==10) {
      bRtn=TRUE;
    }
  }
  return bRtn;
}

section_t *readIniFile(char *szFileName,char *szTargetSection) {
  FILE *fp=NULL;
  section_t *pSetionTop=NULL,*pSection=NULL;
  int rtn=1;
  char szBuffer[4096];
  char szMessage[1024];
  char *b,*d;

  long no;
  char mode;
  int ncount;
  item_t *pitem,**ppitem;
  drop_t *pdrop;
  step_t *pstep;
  char type;
  int idx;
  int iLen;
  int i=0;
  int j;

  fp=fopen(szFileName,"rb");
  if (fp==NULL) {
    MessageBox(NULL,"ݒt@C܂",PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    rtn=0;
    goto errorexit;
  }
  while (1) {
    i++;
    if (fgets(szBuffer,sizeof(szBuffer),fp)!=NULL) {
      for (char *b=szBuffer;*b;b++) if (*b=='\r'||*b=='\n') *b='\0';
      if (lstrlen(szBuffer)>4000) {
        sprintf(szMessage,"ݒt@Cɒs(4000ȏ)܂(%ds)",i);
        MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
        rtn=0;
        goto errorexit;
      }
    } else {
      szBuffer[0]='\0';
    }
    if ((feof(fp)&&szBuffer[0]=='\0')||szBuffer[0]=='[') {
      if (pSection!=NULL) {
        pSection->next=pSectionTop;
        pSectionTop=pSection;
        pSection=NULL;
      }
      if (feof(fp)) {
        break;
      }
    }
    if (szBuffer[0]=='\0') {
      // s
      ;
    } else
    if (szBuffer[0]==';') {
      // Rgs
      ;
    } else
    if (szBuffer[0]=='[') {
      // ZNV
      if (lstrlen(szBuffer)>1&&szBuffer[strlen(szBuffer)-1]==']') {
        szBuffer[strlen(szBuffer)-1]='\0';
        if (szTargetSection==NULL || stricmp(szTargetSection,szBuffer+1)==0) {
          iLen=sizeof(section_t)+strlen(szBuffer+1)+1;
          pSection=(section_t *)malloc(iLen);
          memset(pSection,0x00,iLen);
          pSection->name=(char *)(pSection+1);
          lstrcpy(pSection->name,szBuffer+1);
        }
      } else {
        sprintf(szMessage,"ZNV̍śu]vŏIKv܂(%ds)",i);
        MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
        rtn=0;
        goto errorexit;
      }
    } else {
      // g
      if (pSection!=NULL) {
        if (strnicmp(szBuffer,"step",lstrlen("step"))==0||strnicmp(szBuffer,"drop",lstrlen("drop"))==0) {
          b=szBuffer;
          // s̔BstepdropB
          if (strnicmp(b,"step",lstrlen("step"))==0) {
            b+=lstrlen("step");
            mode='S';
            // stepɑunnv𔻒B
            no=0;
            while (*b&&*b>='0'&&*b<='9') {
              no=no*10+(*b-'0');
              b++;
              if (no>=100000) {
                sprintf(szMessage,"step̐傫܂(100000)(%ds)",i);
                MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                rtn=0;
                goto errorexit;
              }
            }
            for (step_t *pStep2=pSection->step;pStep2!=NULL;pStep2=pStep2->next) {
              if (no==pStep2->no) {
                sprintf(szMessage,"step̏Ԃɓԍ(%d)݂܂(Qڂ̏o%ds)",pStep2->no,i);
                MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                rtn=0;
                goto errorexit;
              }
            }
          } else
          if (strnicmp(szBuffer,"drop",lstrlen("drop"))==0) {
            b+=lstrlen("drop");
            mode='D';
          }
          // 󔒕ǂݔ΂
          while (*b&&(*b==' '||*b=='\t')) b++;
          // stepnndropɑu=v𔻒
          if (*b!='=') {
            sprintf(szMessage,"u=v݂܂(%ds)",i);
            MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
            rtn=0;
            goto errorexit;
          }
          b++;

          // 󔒕ǂݔ΂
          while (*b&&(*b==' '||*b=='\t')) b++;

          // eitemp̊mۂɕKvȐ߂
          ncount=0;
          for (d=b;*d;d++) {
            if (*d==',') {
              ncount++;
            }
          }
          ncount++;

          // eitemp̃̊m
          if (mode=='S') {
            iLen=sizeof(step_t)+sizeof(item_t)*ncount;
            pstep=(step_t *)malloc(iLen);
            memset(pstep,0x00,iLen);
            pstep->srcitem=(item_t *)(pstep+1);
            pstep->dstitem=pstep->srcitem+1;
            pitem=pstep->srcitem;
            pstep->dstcount=ncount-1;
            pstep->no=no;
          } else
          if (mode=='D') {
            if (pSection->drop!=NULL) {
              sprintf(szMessage,"̃ZNVdrop`Ă܂(Qڂ̒`%ds)",i);
              MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
              rtn=0;
              goto errorexit;
            }
            iLen=sizeof(drop_t)+sizeof(item_t)*ncount;
            pdrop=(drop_t *)malloc(iLen);
            memset(pdrop,0x00,iLen);
            pdrop->dropitem=(item_t *)(pdrop+1);
            pitem=pdrop->dropitem;
            pdrop->dropcount=ncount;
          }

          // eitem荞
          d=b;j=0;
          while (*d) {
            type=0;
            if (strnicmp(d,"base",4)==0&&(d[4]=='-'||isnumber(d[4]))) {
              type='B';
              d+=4;
            } else
            if (strnicmp(d,"details",7)==0&&(d[7]=='-'||isnumber(d[7]))) {
              type='D';
              d+=7;
            } else
            if (strnicmp(d,"other",5)==0&&(d[5]=='-'||isnumber(d[5]))) {
              type='O';
              d+=5;
            } else
            if (strnicmp(d,"b",1)==0&&(d[1]=='-'||isnumber(d[1]))) {
              type='B';
              d+=1;
            } else
            if (strnicmp(d,"d",1)==0&&(d[1]=='-'||isnumber(d[1]))) {
              type='D';
              d+=1;
            } else
            if (strnicmp(d,"o",1)==0&&(d[1]=='-'||isnumber(d[1]))) {
              type='O';
              d+=1;
            } else {
              sprintf(szMessage,"vfbase,details,other̂ꂩł(%ds/%dԖ)",i,j+1);
              MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
              rtn=0;
              goto errorexit;
            }
            // '-'͓ǂ݂Ƃ΂B
            if (*d=='-') {
              d++;
            }

            // base/details/otherɑunnv𔻒B
            idx=0;
            while (*d&&*d>='0'&&*d<='9') {
              idx=idx*10+(*d-'0');
              d++;
              if (idx>=100000) {
                sprintf(szMessage,"vf̓Yʂɑ傫܂(100000)(%ds/%dԖ)",i,j+1);
                MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                rtn=0;
                goto errorexit;
              }
            }

            // 󔒕ǂݔ΂
            while (*d&&(*d==' '||*d=='\t')) d++;

            if (*d) {
              if (*d==',') {
                d++;
                // 󔒕ǂݔ΂
                while (*d&&(*d==' '||*d=='\t')) d++;
              } else {
                sprintf(szMessage,"vf̋؂́u,vłKv܂BvfɕςȂ̂Ă܂(%ds/%dԖڂ̌)",i,j+1);
                MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                rtn=0;
                goto errorexit;
              }
            }

            if (Item2Index(type,idx)==0) {
              sprintf(szMessage,"vf̓Y̗vf͈̔͂OĂ܂(%ds/%dԖ/vf'%c'/Y %d)",i,j+1,type,idx);
              MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
              rtn=0;
              goto errorexit;
            }

            if (mode=='S') {
              if (j>0) {
                if (isDateItem(type,idx)&&!isDateItem(pstep->srcitem->type,pstep->srcitem->no)) {
                  sprintf(szMessage,"t^ȊO̍ڂt^̍ڂɐݒ肷邱Ƃ͂ł܂(%ds/%dԖ/vf'%c'/Y %d)",i,j+1);
                  MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                  rtn=0;
                  goto errorexit;
                } else
                if (!isDateItem(type,idx)&&isDateItem(pstep->srcitem->type,pstep->srcitem->no)) {
                  sprintf(szMessage,"t^̍ڂt^ȊO̍ڂɐݒ肷邱Ƃ͂ł܂(%ds/%dԖ/vf'%c'/Y %d)",i,j+1);
                  MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
                  rtn=0;
                  goto errorexit;
                }
              }
            }
            // vfݒ
            pitem->type=type;
            pitem->no=idx;
            pitem++;
            j++;

          }

          // stepdropsectionɐݒ
          if (mode=='S') {
            if (j<2) {
              sprintf(szMessage,"stepɂ2ȏ̗vf(1Ɛ悪1ȏ)Kvł(%ds)",i);
              MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
              rtn=0;
              goto errorexit;
            }
            pstep->next=pSection->step;
            pSection->step=pstep;
            pstep=NULL;
          } else
          if (mode=='D') {
            if (j<1) {
              sprintf(szMessage,"dropɂ1ȏ̗vfKvł(%ds)",i);
              MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
              rtn=0;
              goto errorexit;
            }
            pSection->drop=pdrop;
            pdrop=NULL;
          }
        } else {
          // ȍs
          ;
        }
      }
    }
  }
  if (szTargetSection!=NULL && pSectionTop==NULL) {
    sprintf(szMessage,"Ώۂpluginp̃ZNV(%s)܂",szTargetSection);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    rtn=0;
    goto errorexit;
  }

errorexit:
  if (fp!=NULL) {
    fclose(fp);
    fp=NULL;
  }
  if (pstep) {
    free(pstep);
    pstep=NULL;
  }
  if (pdrop) {
    free(pdrop);
    pdrop=NULL;
  }
  if (pSection) {
    freeIniSection(pSection);
    pSection=NULL;
  }
  if (rtn==0) {
    if (pSectionTop!=NULL) {
      freeIniFile(pSectionTop);
      pSectionTop=NULL;
    }
  }
  return pSectionTop;
}

void freeIniSection(section_t *pSection) {
  if (pSection!=NULL) {
    if (pSection->drop) {
      free(pSection->drop);
    }
    if (pSection->step) {
      free(pSection->step);
    }
    free(pSection);
  }
  return;
}

int freeIniFile(section_t *pSectionTop) {
  section_t *pSection,*pSectionBk;
  pSection=pSectionTop;
  while (pSection!=NULL) {
    pSectionBk=pSection->next;
    freeIniSection(pSection);
    pSection=pSectionBk;
  }
  return 0;
}

int sortStep(section_t *pSection) {
  char szMessage[1024];
  step_t *pStep,**ppStep,*pStep2,**ppStep2,*pStep3,**ppStep3;

  for (ppStep=&(pSection->step),pStep=*ppStep;pStep!=NULL;ppStep=&(pStep->next),pStep=*ppStep) {
    ppStep3=ppStep;pStep3=*ppStep3;
    for (ppStep2=&(pStep->next),pStep2=*ppStep2;pStep2!=NULL;ppStep2=&(pStep2->next),pStep2=*ppStep2) {
      if (pStep2->no < pStep3->no) {
        ppStep3=ppStep2;pStep3=pStep2;
      } else
      if (pStep2->no == pStep3->no) {
        sprintf(szMessage,"ZNV[%s]step̏Ԃɓԍ(%d)݂܂",pSection->name,pStep2->no);
        MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
        return 1;
      }
    }
    if (pStep != pStep3) {
      *ppStep3=pStep;
      *ppStep=pStep3;
      pStep2=pStep->next;
      pStep->next=pStep3->next;
      pStep3->next=pStep2;

      pStep=pStep3;
    }
  }
  return 0;
}

void initFolder(void)
{
  char szModuleFileName[MAX_PATH+1];
  DWORD dwLen;
  char *b,*p;

  // vZXN({Ǘ{)̃pX擾
  hMain = GetModuleHandle(NULL);
  dwLen = GetModuleFileName(hMain, szModuleFileName, sizeof(szModuleFileName)-1);
  szModuleFileName[dwLen]=0;
  lstrcpy(szMainFileName,szModuleFileName);
  lstrcpy(szBaseFolder,szModuleFileName);
  for (b=NULL,p=szBaseFolder;*p;p++) {
    if (*p=='\\') {
      b=p;
    }
  }
  if (b) {
    *b='\0';
  }

  // pluging̃pX擾
  dwLen = GetModuleFileName(hInstance, szModuleFileName, sizeof(szModuleFileName)-1);
  szModuleFileName[dwLen]=0;
  lstrcpy(szPluginFolder,szModuleFileName);
  for (b=NULL,p=szPluginFolder;*p;p++) {
    if (*p=='\\') {
      b=p;
    }
  }
  if (b) {
    lstrcpy(szMyFileName,b+1);
    *b='\0';
  }

  if (strlen(szMyFileName)>strlen(szSufix) && stricmp(szMyFileName+strlen(szMyFileName)-strlen(szSufix),szSufix)==0) {
    strcpy(szPlugin,szMyFileName);
    szPlugin[strlen(szMyFileName)-strlen(szSufix)]='\0';
  } else {
    szPlugin[0]='\0';
  }
  return;
}

extern "C" __declspec(dllexport) void WINAPI funcDownloadDummy(char *WorkPath,char *tempFileName,char *FindStr)
{
  char szModuleFileName[MAX_PATH+1];
  char szFuncName[BUFFER_SIZE];
  char szShowName[BUFFER_SIZE];
  char szAuthorName[BUFFER_SIZE];
  char szVersion[BUFFER_SIZE];
  char szStart[BUFFER_SIZE];
  char szMessage[1024];
  char szAddMessage[1024];
  funcGetInfo_t pFuncGetInfo=NULL;

  initFolder();

  szAddMessage[0]=0;
  if (szPlugin[0]!='\0') {
    while (1) {
      lstrcpy(szModuleFileName,szPluginFolder);
      lstrcat(szModuleFileName,"\\");
      lstrcat(szModuleFileName,szPlugin);
      lstrcat(szModuleFileName,".dll");
      hPlugin=LoadLibrary(szModuleFileName);
      if (hPlugin==NULL) {
        sprintf(szAddMessage,"Plugin(%s)̃t@C܂",szPlugin);
        break;
      }
      pFuncGetInfo=(funcGetInfo_t)GetProcAddress(hPlugin,"funcGetInfo");
      if (pFuncGetInfo==NULL) {
        sprintf(szAddMessage,"Plugin(%s)Pluginł͖C܂",szPlugin);
        break;
      }
      (*pFuncGetInfo)(WorkPath,szFuncName,szShowName,szAuthorName,szVersion,szStart,BUFFER_SIZE);
      if (lstrcmp(szStart,"3")!=0) {
        sprintf(szAddMessage,"Plugin(%s)͌pPluginł͖C܂",szPlugin);
        break;
      }
      sprintf(szAddMessage,"Plugin(%s)͌_ł͐ȋC܂",szPlugin);
      break;
    }
    if (hPlugin) {
      FreeLibrary(hPlugin);
      hPlugin=NULL;
    }
  } else {
    if (stricmp(szMyFileName,szOriginalFileName)!=0) {
      sprintf(szAddMessage,"t@C(%s)͐ȂC܂",szMyFileName);
    }
  }

  sprintf(szMessage,"{plugin̓t@CύXĎgp܂B\r\n"
                  "Ⴆ΁A{plugingppplugiñt@Choge.dll̏ꍇA\r\n"
                  "hoge_exchange.dll Ƃt@Cɂ܂B\r\n"
                  "{bZ[ẂAt@C*_exchange.dllł͖A\r\n"
                  "Y錟pplugindllȂꍇɕ\܂B\r\n"
                  "%s",szAddMessage);
  MessageBox(NULL,szMessage,PLUGIN_ShowName_base,MB_OK|MB_ICONINFORMATION);
  return;
}

extern "C" __declspec(dllexport) void WINAPI funcDownload(char *WorkPath,char *tempFileName,char *FindStr)
{
  char szFuncName[BUFFER_SIZE];
  char szShowName[BUFFER_SIZE];
  char szAuthorName[BUFFER_SIZE];
  char szVersion[BUFFER_SIZE];
  char szStart[BUFFER_SIZE];

  char szMessage[1024];
  char szModuleFileName[MAX_PATH+1];

  char szTempDir[MAX_PATH];
  char szTempFileName[MAX_PATH];
  szTempFileName[0]='\0';
  FILE *ifp=NULL,*ofp=NULL;
  char szBuffer[256*256];
  char *b,*d;
  char *pArray[256];
  char *pArray2[256];
  DWORD dwLen;
  int i;
  int idx,idx2;
  item_t *pItem;
  step_t *pStep;

  funcGetInfo_t pFuncGetInfo=NULL;
  funcDownload_t pFuncDownload=NULL;

//  dfp=fopen("d:\\degug.txt","wb");

  initFolder();

  if (szPlugin[0]=='\0') {
    sprintf(szMessage,"Ήpluginsł",szPlugin);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }

  lstrcpy(szModuleFileName,szPluginFolder);
  lstrcat(szModuleFileName,"\\");
  lstrcat(szModuleFileName,szPlugin);
  lstrcat(szModuleFileName,".dll");
  hPlugin=LoadLibrary(szModuleFileName);
  if (hPlugin==NULL) {
    sprintf(szMessage,"%s̃I[vɎs܂B\r\n{ǗplugintH_ɊỸvOC܂B",szPlugin);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }
  pFuncGetInfo=(funcGetInfo_t)GetProcAddress(hPlugin,"funcGetInfo");
  if (pFuncGetInfo==NULL) {
    sprintf(szMessage,"%sfuncGetInfo̎擾Ɏs܂B\r\nPluginł͖\܂B",szPlugin);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }
  (*pFuncGetInfo)(WorkPath,szFuncName,szShowName,szAuthorName,szVersion,szStart,BUFFER_SIZE);
  if (lstrcmp(szStart,"3")!=0) {
    sprintf(szMessage,"%s͌pPluginł͂܂B",szPlugin);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }
  pFuncDownload=(funcDownload_t)GetProcAddress(hPlugin,szFuncName);
  if (pFuncDownload==NULL) {
    sprintf(szMessage,"%s̏(%s)̎擾Ɏs܂B\r\nPluginł͖\܂B",szFuncName,szPlugin);
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }

  lstrcpy(szModuleFileName,szPluginFolder);
  lstrcat(szModuleFileName,"\\");
  lstrcat(szModuleFileName,szIniFileName);
  pSectionTop=readIniFile(szModuleFileName,szPlugin);
  if (pSectionTop==NULL) {
    goto errorexit;
  }
  if (sortStep(pSectionTop)!=0) {
    goto errorexit;
  }

  dwLen=GetTempPath(sizeof(szTempDir),szTempDir);
  if (dwLen==0||dwLen>sizeof(szTempDir)) {
    sprintf(szMessage,"TEMPtH_̎擾Ɏs܂");
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }
  if (GetTempFileName(szTempDir,szPrefix,0,szTempFileName)==0) {
    sprintf(szMessage,"TEMPt@C̎擾/쐬Ɏs܂");
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }

  // qvOČĂяo
  (*pFuncDownload)(WorkPath,szTempFileName,FindStr);

  ifp=fopen(szTempFileName,"rb");
  if (ifp==NULL) {
    sprintf(szMessage,"Plugiňʃt@C̃I[vɎs܂");
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }
  DeleteFile(tempFileName);
  ofp=fopen(tempFileName,"wb");
  if (ofp==NULL) {
    sprintf(szMessage,"o̓t@C̃I[vɎs܂");
    MessageBox(NULL,szMessage,PLUGIN_ShowName,MB_OK|MB_ICONERROR);
    goto errorexit;
  }

  while (1) {
    // PsǂݍށB
    if (fgets(szBuffer,sizeof(szBuffer),ifp)!=NULL) {
      for (b=szBuffer;*b;b++) if (*b=='\r'||*b=='\n') *b='\0';
      if (lstrlen(szBuffer)>65000) {
        MessageBox(NULL,"ʂɒs(65000ȏ)܂",PLUGIN_ShowName,MB_OK|MB_ICONERROR);
        goto errorexit;
      }
    } else {
      szBuffer[0]='\0';
    }
    if (szBuffer[0]=='\0'&&feof(ifp)) {
      break;
    }
    // u,vŐ؂蕪zɂB
    memset(pArray,0x00,sizeof(pArray));
    for (b=szBuffer,i=0,d=szBuffer;*b;b++) {
      if (*b==',') {
        pArray[i]=d;
        d=b+1;
        *b=0;
        i++;
      }
    }
    pArray[i]=d;

    // Sڂ𕡐
    memcpy(pArray2,pArray,sizeof(pArray));
    // dropŵ鍀ڂ(NULLɂ)
    if (pSectionTop->drop!=NULL) {
      for (pItem=pSectionTop->drop->dropitem,i=0;i<pSectionTop->drop->dropcount;i++,pItem++) {
        idx=Item2Index(pItem->type,pItem->no);
        if (idx>0) {
          idx--;
          pArray2[idx]=NULL;
          if (isDateItem(pItem->type,pItem->no)) {
            pArray2[idx+1]=NULL;
            pArray2[idx+2]=NULL;
          }
        }
      }
    }
    // estepsourceɎw肳Ă鍀ڂ(NULLɂ)
    for (pStep=pSectionTop->step;pStep!=NULL;pStep=pStep->next) {
      idx2=Item2Index(pStep->srcitem->type,pStep->srcitem->no);
      if (idx2>0) {
        idx2--;
        pArray2[idx2]=NULL;
        if (isDateItem(pStep->srcitem->type,pStep->srcitem->no)) {
          pArray2[idx2+1]=NULL;
          pArray2[idx2+2]=NULL;
        }
      }
    }
    // estepɂ镡s
    for (pStep=pSectionTop->step;pStep!=NULL;pStep=pStep->next) {
//fprintf(dfp,"step(%d):start\r\n",pStep->no);
      idx2=Item2Index(pStep->srcitem->type,pStep->srcitem->no);
//fprintf(dfp,"step(%d):src:%d\r\n",pStep->no,idx2);
      if (idx2>0) {
        idx2--;
        for (pItem=pStep->dstitem,i=0;i<pStep->dstcount;i++,pItem++) {
          idx=Item2Index(pItem->type,pItem->no);
//fprintf(dfp,"step(%d):dst(%d):%d\r\n",pStep->no,i+1,idx);
          if (idx>0) {
            idx--;
            if (isDateItem(pStep->srcitem->type,pStep->srcitem->no)) {
              if (isDateItem(pItem->type,pItem->no)) {
                pArray2[idx]=pArray[idx2];
                pArray2[idx+1]=pArray[idx2+1];
                pArray2[idx+2]=pArray[idx2+2];
              } else {
//fprintf(dfp,"step(%d):dst(%d):%c-%d%c-%d\r\n",pStep->no,i+1,pStep->srcitem->type,pStep->srcitem->no,pItem->type,pItem->no);
              }
            } else {
              if (isDateItem(pItem->type,pItem->no)) {
//fprintf(dfp,"step(%d):dst(%d):%c-%d%c-%d\r\n",pStep->no,i+1,pStep->srcitem->type,pStep->srcitem->no,pItem->type,pItem->no);
              } else {
                pArray2[idx]=pArray[idx2];
              }
            }
          } else {
//fprintf(dfp,"step(%d):dst(%d):%c-%d\r\n",pStep->no,i+1,pItem->type,pItem->no);
          }
        }
      } else {
//fprintf(dfp,"step(%d):src:%c-%d\r\n",pStep->no,pStep->srcitem->type,pStep->srcitem->no);
      }
    }
    for (i=0;i<68;i++) {
      if (i!=0) {
        fprintf(ofp,",");
//        fprintf(dfp,",");
      }
      if (pArray2[i]) {
        fprintf(ofp,"%s",pArray2[i]);
//        fprintf(dfp,"%s",pArray2[i]);
      }
    }
    fprintf(ofp,"\r\n");
//    fprintf(dfp,"\r\n");
  }

errorexit:
  if (ifp!=NULL) {
    fclose(ifp);
    ifp=NULL;
  }
  if (ofp!=NULL) {
    fclose(ofp);
    ofp=NULL;
  }
//  if (dfp!=NULL) {
//    fclose(dfp);
//    dfp=NULL;
//  }
  if (pSectionTop!=NULL) {
    freeIniFile(pSectionTop);
    pSectionTop=NULL;
  }
  if (szTempFileName[0]) {
    DeleteFile(szTempFileName);
    szTempFileName[0]='\0';
  }
  if (hPlugin) {
    FreeLibrary(hPlugin);
    hPlugin=NULL;
  }

  return;
}

extern "C" __declspec(dllexport) void WINAPI funcGetInfo(char *WorkPath,char *FuncName,char *ShowName,char *AuthorName,char *Version,char *Start,WORD Size)
{
  char szModuleFileName[MAX_PATH+1];
  char szFuncName[BUFFER_SIZE];
  char szShowName[BUFFER_SIZE];
  char szAuthorName[BUFFER_SIZE];
  char szVersion[BUFFER_SIZE];
  char szStart[BUFFER_SIZE];
  char szMessage[1024];
  char szErrorName[1024];
  funcGetInfo_t pFuncGetInfo=NULL;

  initFolder();

  szErrorName[0]=0;
  if (szPlugin[0]!='\0') {
    while (1) {
      lstrcpy(szModuleFileName,szPluginFolder);
      lstrcat(szModuleFileName,"\\");
      lstrcat(szModuleFileName,szPlugin);
      lstrcat(szModuleFileName,".dll");
      hPlugin=LoadLibrary(szModuleFileName);
      if (hPlugin==NULL) {
        lstrcpy(szErrorName,szPlugin);
        szPlugin[0]=0;
        break;
      }
      pFuncGetInfo=(funcGetInfo_t)GetProcAddress(hPlugin,"funcGetInfo");
      if (pFuncGetInfo==NULL) {
        lstrcpy(szErrorName,szPlugin);
        szPlugin[0]=0;
        break;
      }
      (*pFuncGetInfo)(WorkPath,szFuncName,szShowName,szAuthorName,szVersion,szStart,BUFFER_SIZE);
      if (lstrcmp(szStart,"3")!=0) {
        lstrcpy(szErrorName,szPlugin);
        szPlugin[0]=0;
        break;
      }
      lstrcpyn(FuncName,PLUGIN_FuncName,Size-1);
      sprintf(szMessage,PLUGIN_ShowName_search,szPlugin);
      lstrcpyn(ShowName,szMessage,Size-1);
      sprintf(szMessage,"%s(+%s)",szAuthorName,PLUGIN_AuthorName);
      lstrcpyn(AuthorName,szMessage,Size-1);
      sprintf(szMessage,"%s(%s)",szVersion,PLUGIN_Version);
      lstrcpyn(Version,szMessage,Size-1);
      lstrcpyn(Start,PLUGIN_Start,Size-1);
      break;
    }
    if (hPlugin) {
      FreeLibrary(hPlugin);
      hPlugin=NULL;
    }
  } else {
    if (stricmp(szMyFileName,szOriginalFileName)!=0) {
      lstrcpy(szErrorName,szMyFileName);
    }
  }
  if (szPlugin[0]=='\0') {
    lstrcpyn(FuncName,PLUGIN_FuncName_base,Size-1);
    if (szErrorName[0]==0) {
      lstrcpyn(ShowName,PLUGIN_ShowName_base,Size-1);
    } else {
      sprintf(szMessage,PLUGIN_ShowName_base_error,szErrorName);
      lstrcpyn(ShowName,szMessage,Size-1);
    }
    lstrcpyn(AuthorName,PLUGIN_AuthorName,Size-1);
    lstrcpyn(Version,PLUGIN_Version,Size-1);
    lstrcpyn(Start,PLUGIN_Start_base,Size-1);
  }
  return;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
      hInstance = hinstDLL;
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:
      break;
  }
  return TRUE;
}
